#
# This Mod was created by Defiant <mail@defiant.homedns.org>
# and is under the GNU GPL License (watch README)!
# 
# Basic TractorTargetDocked() and TractorBeamOn() are from the SDK and
# some parts of GetShuttlesInBay(), IncreaseShuttleCount() and ShuttlesInBayOfThisType()
# are copied from sleight42 Shuttle Launching Framework.
#
# SetMaxShuttlesInBay() & GetOEPs() by Sim Rex
# Quote by Sim Rex: "btw, I have no idea what the ftb guys were smoking when they came up
#  with this very convoluted way of launching stuff...."
#
#
# Have Fun!

import App
import MissionLib
import ftb.ShipManager

pGame = App.Game_GetCurrentGame()
pEpisode = pGame.GetCurrentEpisode()
pMission = pEpisode.GetCurrentMission()

g_pMissionDatabase 	= None
g_pFelix		= None
g_pBrex			= None


# Here we Count the Shuttles in our Bay
# Basicly copied from the Shuttle Launching Framework by sleight42 (AddLaunchButtons() in LaunchShipHandlers.py)
def GetShuttlesInBay():	
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	pLaunchers = pCarrier.GetLaunchers()
	numTypes = len( pLaunchers)
	for index in range( numTypes):
		launchType = pLaunchers[index].GetLaunchType()
		numLaunches =  pLaunchers[index].GetNumLaunches( launchType)
		firstlaunchType = launchType
		
		launchType = None
		
		i = 0
		while (launchType != firstlaunchType):
			launchType = pLaunchers[index].NextLaunchType()
			if (launchType != firstlaunchType):
				numLaunches =  numLaunches + pLaunchers[index].GetNumLaunches( launchType)
			
			if ( i > 10 ):
			# This makes sure the Game is not crashing if we have 0 Shuttles in Bay.
				return 0
			i = i + 1
			
	return numLaunches


#How much Shuttles can we get in our Bay?
def GetMaxShuttlesInBay(OurShipName):
	return SetMaxShuttlesInBay(OurShipName)
	# Carrier Plugin to be used
	#import Custom.Carriers.MaxShuttlesInBay
	#MaxShuttlesInBay = Custom.Carriers.MaxShuttlesInBay.SetMaxShuttlesInBay(OurShipName)
	#return MaxShuttlesInBay


# Now the hard Work with the ftb begins!
def IncreaseShuttleCount(Shuttle):
	#print("Trying to increase Shuttle Count")

	import string
	ShipString = string.split(Shuttle, ' ')
	#print(ShipString[:1])
	if ( string.find(str(ShipString[:1]), '-') != "-1" ):
		#print("- still found")
		ShipString = string.split(Shuttle, '-')
		#print(ShipString[:1])
		
	# damm...this looks to much like logo for me...
	ShipType = string.replace(string.replace(str(ShipString[:1]), '\']', ''), '[\'', '')
	# ^^Dont ask me, what this is doing, I forget it 2 hours after writing...it just...works
	ShipType = string.replace(ShipType, ' ', '')
	# And now we deal with the last spaces
	#print(ShipType)


	ShipCount = ShuttlesInBayOfThisType(ShipType)
	#print("Ship Counts:")
	#print(ShipCount)
	
	ShuttleCountCorrection = 0
	if ( ShipCount > 0 ):
		#print("Correction needed")
		ShuttleCountCorrection = 1

	pShip = App.Game_GetCurrentPlayer()

	# TODO: If we started all Shuttles the Carrier System sucks up...trying to fix...
	# Not working yet
	if ( ShipCount == 0 ):
		print("Trying to get Carrier System working again")
		print("Bad: that Function is not working yet :(")
		#import ftb.LaunchShipHandlers
		#global pLaunchButton
		#pLaunchButton = ftb.LaunchShipHandlers.pLaunchButton
		#pLaunchButton[1].SetEnabled()

		#import ftb.LaunchShip
		#ET_MAY_LAUNCH_SHUTTLE_AGAIN = ftb.LaunchShip.ET_MAY_LAUNCH_SHUTTLE_AGAIN
		#import ftb.LaunchShipHandlers
		#ftb.LaunchShipHandlers.MayLaunchShuttleAgain(ET_MAY_LAUNCH_SHUTTLE_AGAIN, pGame)
	
	# Thats from the Carrier System config by Sleight42
	LauncherManager = __import__( "ftb.LauncherManager")
	launcher = LauncherManager.GetLauncher( GetFirstShuttleBayName(), pShip)
	launcher.AddLaunchable( ShipType, "QuickBattle.QuickBattleFriendlyAI", 1)
	
	if ( ShuttleCountCorrection == 1 ):
		# We have to do this, cause sometimes launcher.AddLaunchable only overwrite the count.
		ShipCountCorrection = ShuttlesInBayOfThisType(ShipType)
		#print(ShipCountCorrection)
		if ( ShipCountCorrection == 1 ):
			#print ("Doing correction")
			# again from the Carrier System config by Sleight42
			launcher.AddLaunchable( ShipType, "QuickBattle.QuickBattleFriendlyAI", ShipCount + 1)
	
	#print(ShipCount)
		

# just a split of the old GetShuttleBay()
def GetShuttleBaySize(OurShipName, pEvent, pShip):
	ShuttleBaySize = FindAShuttleBay(OurShipName, pEvent, pShip).GetRadius()
	return ShuttleBaySize


# This make sure we don't destroy the other Shuttles in this Bay
# Its mostly the same like GetShuttlesInBay(), so also from the Shuttle Launching Framework by sleight42.
def ShuttlesInBayOfThisType(Type):
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	pLaunchers = pCarrier.GetLaunchers()
	numTypes = len( pLaunchers)
	for index in range( numTypes):
		launchType = None
				
		i = 0
		while (launchType != Type):
			#print(Type)
			#print(launchType)
			launchType = pLaunchers[index].NextLaunchType()
			numLaunches =  pLaunchers[index].GetNumLaunches( launchType)
			if ( i > 10 ):
			# Stop crashing Stupid Game
				return 0
			i = i + 1
	
	return numLaunches
	

# Actually based on MissionLib().FindShuttleBay()
def FindAShuttleBay(OurShipName, pEvent, pShip):
	iShipID = pShip.GetObjID()

	pPropSet = pShip.GetPropertySet()
	pHullPropInstanceList = pPropSet.GetPropertiesByType(App.CT_HULL_PROPERTY)
	
	pHullPropInstanceList.TGBeginIteration()
	iNumItems = pHullPropInstanceList.TGGetNumItems()
	
	pLaunchProperty = None

	for i in range(iNumItems):
		pInstance = pHullPropInstanceList.TGGetNext()

		# Check to see if the property for this instance is a Hull Property
		pProperty = App.HullProperty_Cast(pInstance.GetProperty())

		if (pProperty != None):
			if ( pProperty.GetName().CompareC("Shuttle", 1) != -1 ):
				pHullPropInstanceList.TGDoneIterating()
				pHullPropInstanceList.TGDestroy()
				return(pProperty)


# Created by Sim Rex
def SetMaxShuttlesInBay(OurShipName):
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	if hasattr(pCarrier, "GetMaxShuttles"):
		iMaxShuttles = pCarrier.GetMaxShuttles()
	else:
		iMaxShuttles = 10
	return iMaxShuttles


# Created by Sim Rex
# Quote: Took far too long to work that out.. 
# It's a shame that the BC Python version doesn't have the very useful help() function...
# Would've saved me a lot of opening and closing of BC...
def GetOEPs(): 
    pFTBCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer()) 
    pFTBLaunchers = pFTBCarrier.GetLaunchers() 
    OEPList = [] 
    for launcher in pFTBLaunchers: 
        OEPs = launcher.GetLaunchers() 
        OEPList = OEPList + OEPs 
    return OEPList


# Just give me the name of our first Shuttle Bay plz:
def GetFirstShuttleBayName():
	import string
	
	ShuttleBayName = GetOEPs() #calling Sim Rex's Function
	ShuttleBayName = string.replace(string.replace(str(ShuttleBayName[:1]), '\']', ''), '[\'', '')
	# now that is 100% the same crap replace thing like in IncreaseShuttleCount() above.
	return ShuttleBayName


# Modified Version of  Sim Rex's SetMaxShuttlesInBay()
def GetIgnoredTractors(OurShipName):
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	if hasattr(pCarrier, "IgnoreTractors"):
		return pCarrier.IgnoreTractors()
	else:
		return []


################################################################################
##	TractorTargetDocked()
##
##	Event handler called when tractor target has docked with ship.
##
##	Args:	pTGObject	- The TGObject object
##			pEvent		- The event that was sent to the object
##
##	Return:	None
################################################################################
def TractorTargetDocked(pTGObject, pEvent):
	#print("Calling TractorTargetDocked()")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	
	pBridge = App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/QuickBattle/ReturnShuttles.tgl")
	g_pFelix	= App.CharacterClass_GetObject(pBridge, "Tactical")

	# Get the object that was docked and it's name
	pObject	= App.ShipClass_Cast(pEvent.GetObjPtr())
	if (pObject == None):
		return
	pShip	= App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		return
	
	sShipName	= pShip.GetName()
	
	sName 	= pObject.GetName()
	if (sName[:14] == "Rettungskapsel"):
		# It's a pod - thats for the german people.
		sName = "Escape Pod"

	# Remove the Object from the set
	pObject.SetDeleteMe(1)
	
	if (sName[:10] == "Escape Pod"):
		#print("Play the audio line that will let the player know pod is docked")
		FelixLineIs = "E6M2PodDocked"
	else:
		# Increase the captured count
		IncreaseShuttleCount(sName)
		# and the Audio Line is:
		FelixLineIs = "ShipDocked"
	
	# Finally we can play the Audio line with either Pod or Ship line.
	pSequence = App.TGSequence_Create()
	pFelixLine = App.CharacterAction_Create(g_pFelix, App.CharacterAction.AT_SAY_LINE, FelixLineIs, "Captain", 1, g_pMissionDatabase)
	pSequence.AppendAction(pFelixLine, 2) #2 second delay
	pSequence.Play()		

	#print("Tractor Target Docked is finished and done")

################################################################################
##	TractorBeamOn()
##
##	Event handler called when tractor beam starts hitting a target.  Checks to
##	see if the target is a pod and starts docking behavior if it is.
##
##	Args:	TGObject	- The TGObject object.
##			pEvent		- The event that was sent.
##
##	Return:	None
################################################################################
def TractorBeamOn(TGObject, pEvent):
	# Get the event destination (the thing hit by tractor beam)
	#print("Tractor Beam on")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	global g_pBrex
	pBridge 		= App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/QuickBattle/ReturnShuttles.tgl")
	g_pFelix		= App.CharacterClass_GetObject(pBridge, "Tactical")
	g_pBrex			= App.CharacterClass_GetObject(pBridge, "Engineer")
	ShuttleBaySize		= None
	MaxShuttlesInBay	= None
	
	pShip = App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		print("failed - no Ship")
		return
		
	sTargetName = pShip.GetName()
	if (sTargetName[:14] == "Rettungskapsel"):
		# It's a pod - thats for the german people.
		sTargetName = "Escape Pod"
	#print("Target Ship in Tractor is: " + sTargetName)
	
	#Lets try to get the size of our Target ship
	TargetHullSize = pShip.GetHull().GetRadius()
	#print("Size of the Target:")
	#print(TargetHullSize)

	# Get the tractor beam system that fired so we
	# can set it's behavior.
	pTractorProjector	= App.TractorBeamProjector_Cast(pEvent.GetSource())
	pTractorSystem		= App.TractorBeamSystem_Cast(pTractorProjector.GetParentSubsystem())
	
	# Get the name of the ship that fired
	pShip = pTractorSystem.GetParentShip()
	if (pShip == None):
		return
	sFiringShipName = pShip.GetName()
	
	OurShipName = pShip.GetShipProperty().GetShipName()
	#print("Firing Ship Name: " + OurShipName)	
	
	# Test if this Tractor can be used to Dock:
	if ( GetIgnoredTractors(OurShipName).count(pTractorProjector.GetName()) != 0 ):
		return
	
	#and the size of our Shuttle Bay
	ShuttleBaySize=GetShuttleBaySize(OurShipName, pEvent, pShip)
	#print("Size of our Shuttle Bay:");
	if (ShuttleBaySize == None):
		print("ShuttleBaySize not set")
		return
	#print(ShuttleBaySize)
	
	#print("Max Shuttles we can carry:");
	MaxShuttlesInBay=GetMaxShuttlesInBay(OurShipName)
	if (MaxShuttlesInBay == None):
		MaxShuttlesInBay = 10
		print("Setting default MaxShuttlesInBay")
	#print(MaxShuttlesInBay)
	
	ShuttlesInBay=GetShuttlesInBay()
	#print("Shuttles currently in Bay:")
	#print(ShuttlesInBay)
	
	# See if the ship is small enough to fit into out Bay
	if (TargetHullSize < ShuttleBaySize):
		#print("Target is small enough to get in our Bay")

		if (sTargetName[:10] == "Escape Pod"):
			# It's a pod
			#print("Playing Brex's .attempting to dock pod. line")	
			pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "E6M2FelixDockPod", "Captain", 1, g_pMissionDatabase)
			pBrexLine.Play()
			
			# set the tractor beam to pull in and dock the pod
			pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
		else:
			# It's not a Pod
			# Test if we got enough space in our Bay left
			if ( MaxShuttlesInBay > ShuttlesInBay ):
				#print("There is enough space left in our Bay")
				#print("Target will be docked")
				
				#print("Playing Brex's attempting to dock line")	
				pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "FelixDockShip", "Captain", 1, g_pMissionDatabase)
				pBrexLine.Play()

				# set the tractor beam to pull in and dock the pod
				pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
			else:
				print("Sorry: No Space left")
				return

	# We're done.  Let any other handlers for this event handle it.
	#print("Tractor beam on finished")
	TGObject.CallNextHandler(pEvent)
	


#print("Loading Defiants event Handlers to get the Shuttles back")

# Tractor beam target docked event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_TARGET_DOCKED, pMission, __name__+".TractorTargetDocked")
# Tractor beam starts hitting event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_BEAM_STARTED_HITTING, pMission, __name__+".TractorBeamOn")
